import { useCssVars as J, computed as _, onMounted as K, ref as D, watch as Q, openBlock as a, createElementBlock as s, normalizeStyle as $, createElementVNode as y, createTextVNode as Z, toDisplayString as p, unref as r, createCommentVNode as g, Fragment as h, renderList as f, normalizeClass as N, createBlock as I } from "vue";
import { u as ee, o as te, e as H, g as le, c as ae, t as se, s as b, i as V, f as E, X as oe, w as z } from "./index-Bkzd7TEp.js";
import { u as F } from "./useNestedProp-BjKkGjnV.js";
import { _ as ue } from "./Shape-Bw52scDY.js";
import ie from "./vue-ui-skeleton-B1pWkVPT.js";
import { _ as ne } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const re = { key: 0 }, ve = { key: 1 }, de = ["xmlns", "viewBox"], ce = ["id"], ye = ["stop-color"], he = ["stop-color"], fe = ["id"], pe = ["stop-color"], ge = ["stop-color"], be = ["id"], me = ["stop-color"], _e = ["stop-color"], xe = { key: 0 }, ke = ["x", "y", "height", "width", "fill", "stroke", "stroke-width", "rx"], we = { key: 1 }, $e = ["x", "y", "font-size", "font-weight", "fill"], Ce = ["x", "y", "font-size", "fill"], Le = ["x", "y", "font-size", "fill"], ze = ["height", "width", "x", "onMouseover", "stroke", "stroke-width", "rx", "stroke-dasharray", "onClick"], Se = {
  __name: "vue-ui-sparkhistogram",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectDatapoint"],
  setup(W, { emit: B }) {
    const v = W;
    J((l) => ({
      dca3ca72: G.value
    }));
    const { vue_ui_sparkhistogram: O } = ee(), S = _(() => !!v.dataset && v.dataset.length);
    K(() => {
      M();
    });
    function M() {
      te(v.dataset) ? H({
        componentName: "VueUiSparkHistogram",
        type: "dataset"
      }) : v.dataset.forEach((l, i) => {
        le({
          datasetObject: l,
          requiredAttributes: ["value"]
        }).forEach((t) => {
          H({
            componentName: "VueUiSparkHistogram",
            type: "datasetSerieAttribute",
            property: t,
            index: i
          });
        });
      });
    }
    const m = D(ae()), e = _({
      get: () => A(),
      set: (l) => l
    });
    function A() {
      const l = F({
        userConfig: v.config,
        defaultConfig: O
      });
      return l.theme ? {
        ...F({
          userConfig: se.vue_ui_sparkhistogram[l.theme] || v.config,
          defaultConfig: l
        })
      } : l;
    }
    Q(() => v.config, (l) => {
      e.value = A(), M();
    }, { deep: !0 });
    const d = _(() => {
      const l = e.value.style.layout.height, i = e.value.style.layout.width, t = e.value.style.layout.padding.top, o = l - e.value.style.layout.padding.bottom, c = e.value.style.layout.padding.left, x = i - e.value.style.layout.padding.right, k = t + (l - t - e.value.style.layout.padding.bottom) / 2, C = l - e.value.style.layout.padding.top - e.value.style.layout.padding.bottom, w = i - e.value.style.layout.padding.left - e.value.style.layout.padding.right;
      return {
        bottom: o,
        centerY: k,
        drawingHeight: C,
        drawingWidth: w,
        height: l,
        left: c,
        right: x,
        top: t,
        width: i
      };
    }), U = _(() => Math.max(...v.dataset.map((l) => Math.abs(l.value || 0))));
    function X(l) {
      return Math.abs(l) / U.value;
    }
    const n = _(() => v.dataset.map((l, i) => {
      const t = X(l.value || 0), o = d.value.drawingHeight * t, c = d.value.drawingWidth / v.dataset.length, x = c * (e.value.style.bars.gap / 100), k = c - x, C = d.value.centerY - o / 2, w = d.value.left + (x / 2 + i * c), Y = d.value.left + i * c, L = typeof l.intensity > "u" ? 100 : Math.round(l.intensity * 100), q = l.color ? l.color : l.value >= 0 ? b(e.value.style.bars.colors.positive, L) : b(e.value.style.bars.colors.negative, L), R = l.color ? l.color : l.value >= 0 ? e.value.style.bars.colors.positive : e.value.style.bars.colors.negative, T = l.color ? `url(#gradient_datapoint_${i}_${m.value})` : l.value >= 0 ? `url(#gradient_positive_${i}_${m.value})` : `url(#gradient_negative_${i}_${m.value})`, P = w + k / 2;
      return {
        ...l,
        color: q,
        gradient: T,
        height: o,
        intensity: L,
        proportion: t,
        stroke: R,
        textAnchor: P,
        trapX: Y,
        unitWidth: c,
        width: k,
        x: w,
        y: C
      };
    })), u = D(null);
    function j(l, i) {
      B("selectDatapoint", { datapoint: l, index: i });
    }
    const G = _(() => `${e.value.style.animation.speedMs}ms`);
    return (l, i) => (a(), s("div", {
      style: $(`width:100%;background:${e.value.style.backgroundColor};font-family:${e.value.style.fontFamily}`),
      onMouseleave: i[1] || (i[1] = (t) => u.value = null)
    }, [
      e.value.style.title.text ? (a(), s("div", {
        key: 0,
        style: $(`width:calc(100% - 12px);background:transparent;margin:0 auto;margin:${e.value.style.title.margin};padding: 0 6px;text-align:${e.value.style.title.textAlign}`)
      }, [
        y("div", {
          style: $(`font-size:${e.value.style.title.fontSize}px;color:${e.value.style.title.color};font-weight:${e.value.style.title.bold ? "bold" : "normal"}`)
        }, [
          Z(p(e.value.style.title.text) + " ", 1),
          u.value !== null ? (a(), s("span", re, "- " + p(n.value[u.value].timeLabel || "") + " " + p(r(V)(
            e.value.style.labels.value.formatter,
            n.value[u.value].value,
            r(E)({
              p: e.value.style.labels.value.prefix,
              v: n.value[u.value].value,
              s: e.value.style.labels.value.suffix,
              r: e.value.style.labels.value.rounding
            }),
            { datapoint: n.value[u.value], seriesIndex: u.value }
          )), 1)) : g("", !0),
          ![void 0, null].includes(u.value) && ![null, void 0].includes(n.value[u.value].valueLabel) ? (a(), s("span", ve, "(" + p(n.value[u.value].valueLabel || 0) + ")", 1)) : g("", !0)
        ], 4),
        e.value.style.title.subtitle.text ? (a(), s("div", {
          key: 0,
          style: $(`font-size:${e.value.style.title.subtitle.fontSize}px;color:${e.value.style.title.subtitle.color};font-weight:${e.value.style.title.subtitle.bold ? "bold" : "normal"}`)
        }, p(e.value.style.title.subtitle.text), 5)) : g("", !0)
      ], 4)) : g("", !0),
      S.value ? (a(), s("svg", {
        key: 1,
        xmlns: r(oe),
        viewBox: `0 0 ${d.value.width} ${d.value.height}`,
        style: { overflow: "visible" }
      }, [
        y("defs", null, [
          (a(!0), s(h, null, f(n.value, (t, o) => (a(), s("radialGradient", {
            id: `gradient_positive_${o}_${m.value}`,
            cy: "50%",
            cx: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            y("stop", {
              offset: "0%",
              "stop-color": r(b)(r(z)(e.value.style.bars.colors.positive, 0.05), t.intensity)
            }, null, 8, ye),
            y("stop", {
              offset: "100%",
              "stop-color": r(b)(e.value.style.bars.colors.positive, t.intensity)
            }, null, 8, he)
          ], 8, ce))), 256)),
          (a(!0), s(h, null, f(n.value, (t, o) => (a(), s("radialGradient", {
            id: `gradient_negative_${o}_${m.value}`,
            cy: "50%",
            cx: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            y("stop", {
              offset: "0%",
              "stop-color": r(b)(r(z)(e.value.style.bars.colors.negative, 0.05), t.intensity)
            }, null, 8, pe),
            y("stop", {
              offset: "100%",
              "stop-color": r(b)(e.value.style.bars.colors.negative, t.intensity)
            }, null, 8, ge)
          ], 8, fe))), 256)),
          (a(!0), s(h, null, f(n.value, (t, o) => (a(), s("radialGradient", {
            id: `gradient_datapoint_${o}_${m.value}`,
            cy: "50%",
            cx: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            y("stop", {
              offset: "0%",
              "stop-color": r(b)(r(z)(t.color, 0.05), t.intensity)
            }, null, 8, me),
            y("stop", {
              offset: "100%",
              "stop-color": r(b)(t.color, t.intensity)
            }, null, 8, _e)
          ], 8, be))), 256))
        ]),
        !e.value.style.bars.shape || e.value.style.bars.shape === "square" ? (a(), s("g", xe, [
          (a(!0), s(h, null, f(n.value, (t, o) => (a(), s("rect", {
            x: t.x,
            y: t.y,
            height: t.height,
            width: t.width,
            fill: e.value.style.bars.colors.gradient.show ? t.gradient : t.color,
            stroke: t.stroke,
            "stroke-width": e.value.style.bars.strokeWidth,
            rx: `${e.value.style.bars.borderRadius * t.proportion / 12}%`,
            class: N({ "vue-ui-sparkhistogram-shape": e.value.style.animation.show })
          }, null, 10, ke))), 256))
        ])) : (a(), s("g", we, [
          (a(!0), s(h, null, f(n.value, (t, o) => (a(), I(ue, {
            plot: { x: t.x + t.width / 2, y: t.y + t.height / 2 },
            color: e.value.style.bars.colors.gradient.show ? t.gradient : t.color,
            shape: e.value.style.bars.shape,
            radius: t.height * 0.4,
            class: N({ "vue-ui-sparkhistogram-shape": e.value.style.animation.show })
          }, null, 8, ["plot", "color", "shape", "radius", "class"]))), 256))
        ])),
        (a(!0), s(h, null, f(n.value, (t, o) => (a(), s("text", {
          "text-anchor": "middle",
          x: t.textAnchor,
          y: t.y - e.value.style.labels.value.fontSize / 3 + e.value.style.labels.value.offsetY,
          "font-size": e.value.style.labels.value.fontSize,
          "font-weight": e.value.style.labels.value.bold ? "bold" : "normal",
          fill: e.value.style.labels.value.color
        }, p(r(V)(
          e.value.style.labels.value.formatter,
          t.value,
          r(E)({
            p: e.value.style.labels.value.prefix,
            v: t.value,
            s: e.value.style.labels.value.suffix,
            r: e.value.style.labels.value.rounding
          }),
          { datapoint: n.value[u.value], seriesIndex: u.value }
        )), 9, $e))), 256)),
        (a(!0), s(h, null, f(n.value, (t, o) => (a(), s("g", null, [
          t.valueLabel ? (a(), s("text", {
            key: 0,
            x: t.textAnchor,
            y: t.y + t.height + e.value.style.labels.valueLabel.fontSize,
            "font-size": e.value.style.labels.valueLabel.fontSize,
            "text-anchor": "middle",
            fill: e.value.style.labels.valueLabel.color
          }, p(t.valueLabel), 9, Ce)) : g("", !0)
        ]))), 256)),
        (a(!0), s(h, null, f(n.value, (t, o) => (a(), s("g", null, [
          t.timeLabel ? (a(), s("text", {
            key: 0,
            x: t.textAnchor,
            y: d.value.height - e.value.style.labels.timeLabel.fontSize / 2,
            "font-size": e.value.style.labels.timeLabel.fontSize,
            fill: e.value.style.labels.timeLabel.color,
            "text-anchor": "middle"
          }, p(t.timeLabel), 9, Le)) : g("", !0)
        ]))), 256)),
        (a(!0), s(h, null, f(n.value, (t, o) => (a(), s("g", null, [
          y("rect", {
            height: d.value.height,
            width: t.unitWidth,
            fill: "transparent",
            x: t.trapX,
            y: 0,
            onMouseover: (c) => u.value = o,
            onMouseleave: i[0] || (i[0] = (c) => u.value = null),
            stroke: u.value !== null && u.value === o ? e.value.style.selector.stroke : "",
            "stroke-width": u.value !== null && u.value === o ? e.value.style.selector.strokeWidth : 0,
            rx: e.value.style.selector.borderRadius,
            "stroke-dasharray": e.value.style.selector.strokeDasharray,
            onClick: () => j(t, o)
          }, null, 40, ze)
        ]))), 256))
      ], 8, de)) : g("", !0),
      S.value ? g("", !0) : (a(), I(ie, {
        key: 2,
        config: {
          type: "sparkHistogram",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            sparkHistogram: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 36));
  }
}, Ve = /* @__PURE__ */ ne(Se, [["__scopeId", "data-v-da8fd5e0"]]);
export {
  Ve as default
};
