import { ref as d, onMounted as q, onBeforeUnmount as H, withDirectives as R, openBlock as t, createElementBlock as i, normalizeStyle as g, createElementVNode as w, withModifiers as G, withKeys as J, createVNode as Q, normalizeClass as c, renderSlot as m, Fragment as T, createBlock as v, toDisplayString as $, createCommentVNode as s, normalizeProps as z, mergeProps as D, unref as Y } from "vue";
import f from "./BaseIcon-dAh8thfs.js";
import { _ as Z } from "./_plugin-vue_export-helper-CHgC5LLL.js";
import { p } from "./pdf-97UbtKC2.js";
import _ from "./html2canvas.esm-d2sM-0Wm.js";
const ee = {
  beforeMount(e, r) {
    e.clickOutsideEvent = function(a) {
      e === a.target || e.contains(a.target) || r.value(a);
    }, document.addEventListener("click", e.clickOutsideEvent);
  },
  unmounted(e) {
    document.removeEventListener("click", e.clickOutsideEvent);
  }
}, te = ["title", "onClick", "onKeypress"], oe = ["data-open"], ne = {
  __name: "UserOptions",
  props: {
    hasPdf: {
      type: Boolean,
      default: !0
    },
    hasXls: {
      type: Boolean,
      default: !0
    },
    hasImg: {
      type: Boolean,
      default: !1
    },
    hasLabel: {
      type: Boolean,
      default: !1
    },
    isLabelActive: {
      type: Boolean,
      default: !1
    },
    hasTable: {
      type: Boolean,
      default: !1
    },
    hasSort: {
      type: Boolean,
      default: !1
    },
    hasStack: {
      type: Boolean,
      default: !1
    },
    hasTooltip: {
      type: Boolean,
      default: !1
    },
    color: {
      type: String
    },
    backgroundColor: {
      type: String
    },
    isPrinting: {
      type: Boolean,
      default: !1
    },
    isImaging: {
      type: Boolean,
      default: !1
    },
    title: {
      type: String
    },
    uid: {
      type: String
    },
    hasFullscreen: {
      type: Boolean,
      default: !1
    },
    chartElement: {
      type: HTMLElement,
      default: null
    },
    isFullscreen: {
      type: Boolean,
      default: !1
    },
    isStacked: {
      type: Boolean,
      default: !1
    },
    isTooltip: {
      type: Boolean,
      default: !1
    },
    hasAnimation: {
      type: Boolean,
      default: !1
    },
    isAnimation: {
      type: Boolean,
      default: !1
    },
    titles: {
      type: Object,
      default() {
        return {};
      }
    },
    showTooltips: {
      type: Boolean,
      default: !0
    },
    zIndex: {
      type: Number,
      default: 1
    },
    noOffset: {
      type: Boolean,
      default: !0
    },
    position: {
      type: String,
      default: "right"
    }
  },
  emits: ["generatePdf", "generateCsv", "generateImage", "toggleTable", "toggleLabels", "toggleSort", "toggleFullscreen", "toggleStack", "toggleTooltip", "toggleAnimation"],
  setup(e, { emit: r }) {
    const a = e;
    function B() {
      r("generatePdf");
    }
    function C() {
      r("generateCsv");
    }
    function h() {
      r("generateImage");
    }
    const y = d(!1);
    function U() {
      y.value = !y.value, r("toggleTable");
    }
    const S = d(!1), x = d(!0);
    function F() {
      k.value = window.innerWidth > 600, S.value = !S.value, S.value && (x.value = !1);
    }
    function K() {
      a.isPrinting || a.isImaging || (S.value = !1);
    }
    function N() {
      S.value && K();
    }
    const I = d(a.isLabelActive);
    function V() {
      I.value = !I.value, r("toggleLabels");
    }
    const M = d(a.isAnimation);
    function O() {
      M.value = !M.value, r("toggleAnimation");
    }
    function j() {
      r("toggleSort");
    }
    const E = d(a.isStacked);
    function W() {
      E.value = !E.value, r("toggleStack");
    }
    const L = d(a.isTooltip);
    function X() {
      L.value = !L.value, r("toggleTooltip");
    }
    const b = d(!1);
    function P(l) {
      a.chartElement && (l === "in" ? (b.value = !0, a.chartElement.requestFullscreen(), r("toggleFullscreen", !0)) : (b.value = !1, document && document.exitFullscreen(), r("toggleFullscreen", !1)));
    }
    function A(l) {
      document.fullscreenElement ? b.value = !0 : b.value = !1;
    }
    q(() => {
      document.addEventListener("fullscreenchange", A);
    }), H(() => {
      document.removeEventListener("fullscreenchange", A);
    });
    const k = d(window.innerWidth > 600), n = d({
      tooltip: !1,
      pdf: !1,
      csv: !1,
      img: !1,
      table: !1,
      labels: !1,
      sort: !1,
      stack: !1,
      fullscreen: !1,
      animation: !1
    });
    return (l, o) => R((t(), i("div", {
      "data-html2canvas-ignore": "",
      class: "vue-ui-user-options",
      style: g(`z-index: ${e.zIndex}; height: 34px; position: ${b.value ? "fixed" : "absolute"}; top: 0; ${e.position === "right" ? `right:${b.value ? "12px" : "0"}` : `left:${b.value ? "12px" : "0"}`}; padding: 4px; background:transparent;`)
    }, [
      w("div", {
        tabindex: "0",
        title: S.value ? e.titles.close || "" : e.titles.open || "",
        style: g(`width:32px; position: absolute; top: 0;${e.position === "right" ? `right: ${e.noOffset ? 0 : 4}px` : `left: ${e.noOffset ? 0 : 4}px`}; padding: 0 0px; display: flex; align-items:center;justify-content:center;height: 36px;  cursor:pointer; background:transparent`),
        onClick: G(F, ["stop"]),
        onKeypress: J(F, ["enter"])
      }, [
        Q(f, {
          name: S.value ? "close" : "menu",
          stroke: e.color,
          "stroke-width": 2
        }, null, 8, ["name", "stroke"])
      ], 44, te),
      w("div", {
        "data-open": S.value,
        class: c({ "vue-ui-user-options-drawer": !0 }),
        style: g(`background:${e.backgroundColor}; ${e.position === "right" ? `right: ${e.noOffset ? 0 : 4}px` : `left: ${e.noOffset ? 0 : 4}px`}`)
      }, [
        e.hasTooltip ? (t(), i("button", {
          key: 0,
          tabindex: "0",
          class: "vue-ui-user-options-button",
          onClick: X,
          onMouseenter: o[0] || (o[0] = (u) => n.value.tooltip = !0),
          onMouseout: o[1] || (o[1] = (u) => n.value.tooltip = !1)
        }, [
          l.$slots.optionTooltip ? m(l.$slots, "optionTooltip", { key: 0 }, void 0, !0) : (t(), i(T, { key: 1 }, [
            L.value ? (t(), v(f, {
              key: 0,
              name: "tooltip",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"])) : (t(), v(f, {
              key: 1,
              name: "tooltipDisabled",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"]))
          ], 64)),
          k.value && e.titles.tooltip && !l.$slots.optionTooltip ? (t(), i("div", {
            key: 2,
            dir: "auto",
            class: c({ "button-info-left": e.position === "left", "button-info-right": e.position === "right", "button-info-left-visible": e.position === "left" && n.value.tooltip, "button-info-right-visible": e.position === "right" && n.value.tooltip }),
            style: g({ background: e.backgroundColor, color: e.color })
          }, $(e.titles.tooltip), 7)) : s("", !0)
        ], 32)) : s("", !0),
        e.hasPdf ? (t(), i("button", {
          key: 1,
          tabindex: "0",
          class: "vue-ui-user-options-button",
          onClick: B,
          onMouseenter: o[2] || (o[2] = (u) => n.value.pdf = !0),
          onMouseout: o[3] || (o[3] = (u) => n.value.pdf = !1)
        }, [
          l.$slots.optionPdf ? m(l.$slots, "optionPdf", { key: 0 }, void 0, !0) : (t(), i(T, { key: 1 }, [
            e.isPrinting ? (t(), v(f, {
              key: 0,
              name: "spin",
              isSpin: "",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"])) : (t(), v(f, {
              key: 1,
              name: "pdf",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"]))
          ], 64)),
          k.value && e.titles.pdf && !l.$slots.optionPdf ? (t(), i("div", {
            key: 2,
            dir: "auto",
            class: c({ "button-info-left": e.position === "left", "button-info-right": e.position === "right", "button-info-right-visible": e.position === "right" && n.value.pdf, "button-info-left-visible": e.position === "left" && n.value.pdf }),
            style: g({ background: e.backgroundColor, color: e.color })
          }, $(e.titles.pdf), 7)) : s("", !0)
        ], 32)) : s("", !0),
        e.hasXls ? (t(), i("button", {
          key: 2,
          tabindex: "0",
          class: "vue-ui-user-options-button",
          onClick: C,
          onMouseenter: o[4] || (o[4] = (u) => n.value.csv = !0),
          onMouseout: o[5] || (o[5] = (u) => n.value.csv = !1)
        }, [
          l.$slots.optionCsv ? m(l.$slots, "optionCsv", { key: 0 }, void 0, !0) : (t(), v(f, {
            key: 1,
            name: "excel",
            stroke: e.color,
            style: { "pointer-events": "none" }
          }, null, 8, ["stroke"])),
          k.value && e.titles.csv && !l.$slots.optionCsv ? (t(), i("div", {
            key: 2,
            dir: "auto",
            class: c({ "button-info-left": e.position === "left", "button-info-right": e.position === "right", "button-info-right-visible": e.position === "right" && n.value.csv, "button-info-left-visible": e.position === "left" && n.value.csv }),
            style: g({ background: e.backgroundColor, color: e.color })
          }, $(e.titles.csv), 7)) : s("", !0)
        ], 32)) : s("", !0),
        e.hasImg ? (t(), i("button", {
          key: 3,
          tabindex: "0",
          class: "vue-ui-user-options-button",
          onClick: h,
          onMouseenter: o[6] || (o[6] = (u) => n.value.img = !0),
          onMouseout: o[7] || (o[7] = (u) => n.value.img = !1)
        }, [
          l.$slots.optionImg ? m(l.$slots, "optionImg", { key: 0 }, void 0, !0) : (t(), i(T, { key: 1 }, [
            e.isImaging ? (t(), v(f, {
              key: 0,
              name: "spin",
              isSpin: "",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"])) : (t(), v(f, {
              key: 1,
              name: "image",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"]))
          ], 64)),
          k.value && e.titles.img && !l.$slots.optionImg ? (t(), i("div", {
            key: 2,
            dir: "auto",
            class: c({ "button-info-left": e.position === "left", "button-info-right": e.position === "right", "button-info-right-visible": e.position === "right" && n.value.img, "button-info-left-visible": e.position === "left" && n.value.img }),
            style: g({ background: e.backgroundColor, color: e.color })
          }, $(e.titles.img), 7)) : s("", !0)
        ], 32)) : s("", !0),
        e.hasTable ? (t(), i("button", {
          key: 4,
          tabindex: "0",
          class: "vue-ui-user-options-button",
          onClick: U,
          onMouseenter: o[8] || (o[8] = (u) => n.value.table = !0),
          onMouseout: o[9] || (o[9] = (u) => n.value.table = !1)
        }, [
          l.$slots.optionTable ? m(l.$slots, "optionTable", { key: 0 }, void 0, !0) : (t(), v(f, {
            key: 1,
            name: y.value ? "tableClose" : "tableOpen",
            stroke: e.color,
            style: { "pointer-events": "none" }
          }, null, 8, ["name", "stroke"])),
          k.value && e.titles.table && !l.$slots.optionTable ? (t(), i("div", {
            key: 2,
            dir: "auto",
            class: c({ "button-info-left": e.position === "left", "button-info-right": e.position === "right", "button-info-right-visible": e.position === "right" && n.value.table, "button-info-left-visible": e.position === "left" && n.value.table }),
            style: g({ background: e.backgroundColor, color: e.color })
          }, $(e.titles.table), 7)) : s("", !0)
        ], 32)) : s("", !0),
        e.hasLabel ? (t(), i("button", {
          key: 5,
          tabindex: "0",
          class: "vue-ui-user-options-button",
          onClick: V,
          onMouseenter: o[10] || (o[10] = (u) => n.value.labels = !0),
          onMouseout: o[11] || (o[11] = (u) => n.value.labels = !1)
        }, [
          l.$slots.optionLabels ? m(l.$slots, "optionLabels", { key: 0 }, void 0, !0) : (t(), v(f, {
            key: 1,
            name: I.value ? "labelClose" : "labelOpen",
            stroke: e.color,
            style: { "pointer-events": "none" }
          }, null, 8, ["name", "stroke"])),
          k.value && e.titles.labels && !l.$slots.optionLabels ? (t(), i("div", {
            key: 2,
            dir: "auto",
            class: c({ "button-info-left": e.position === "left", "button-info-right": e.position === "right", "button-info-right-visible": e.position === "right" && n.value.labels, "button-info-left-visible": e.position === "left" && n.value.labels }),
            style: g({ background: e.backgroundColor, color: e.color })
          }, $(e.titles.labels), 7)) : s("", !0)
        ], 32)) : s("", !0),
        e.hasSort ? (t(), i("button", {
          key: 6,
          tabindex: "0",
          class: "vue-ui-user-options-button",
          onClick: j,
          onMouseenter: o[12] || (o[12] = (u) => n.value.sort = !0),
          onMouseout: o[13] || (o[13] = (u) => n.value.sort = !1)
        }, [
          l.$slots.optionSort ? m(l.$slots, "optionSort", { key: 0 }, void 0, !0) : (t(), v(f, {
            key: 1,
            name: "sort",
            stroke: e.color,
            style: { "pointer-events": "none" }
          }, null, 8, ["stroke"])),
          k.value && e.titles.sort && !l.$slots.optionSort ? (t(), i("div", {
            key: 2,
            dir: "auto",
            class: c({ "button-info-left": e.position === "left", "button-info-right": e.position === "right", "button-info-right-visible": e.position === "right" && n.value.sort, "button-info-left-visible": e.position === "left" && n.value.sort }),
            style: g({ background: e.backgroundColor, color: e.color })
          }, $(e.titles.sort), 7)) : s("", !0)
        ], 32)) : s("", !0),
        e.hasStack ? (t(), i("button", {
          key: 7,
          tabindex: "0",
          class: "vue-ui-user-options-button",
          onClick: W,
          onMouseenter: o[14] || (o[14] = (u) => n.value.stack = !0),
          onMouseout: o[15] || (o[15] = (u) => n.value.stack = !1)
        }, [
          l.$slots.optionStack ? m(l.$slots, "optionStack", { key: 0 }, void 0, !0) : (t(), i(T, { key: 1 }, [
            E.value ? (t(), v(f, {
              key: 0,
              name: "unstack",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"])) : (t(), v(f, {
              key: 1,
              name: "stack",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"]))
          ], 64)),
          k.value && e.titles.stack && !l.$slots.optionStack ? (t(), i("div", {
            key: 2,
            dir: "auto",
            class: c({ "button-info-left": e.position === "left", "button-info-right": e.position === "right", "button-info-right-visible": e.position === "right" && n.value.stack, "button-info-left-visible": e.position === "left" && n.value.stack }),
            style: g({ background: e.backgroundColor, color: e.color })
          }, $(e.titles.stack), 7)) : s("", !0)
        ], 32)) : s("", !0),
        e.hasFullscreen ? (t(), i("button", {
          key: 8,
          tabindex: "0",
          class: "vue-ui-user-options-button",
          onMouseenter: o[16] || (o[16] = (u) => n.value.fullscreen = !0),
          onMouseout: o[17] || (o[17] = (u) => n.value.fullscreen = !1),
          onClick: o[18] || (o[18] = (u) => P(b.value ? "out" : "in"))
        }, [
          l.$slots.optionFullscreen ? m(l.$slots, "optionFullscreen", z(D({ key: 0 }, { toggleFullscreen: P, isFullscreen: b.value })), void 0, !0) : (t(), i(T, { key: 1 }, [
            b.value ? (t(), v(f, {
              key: 0,
              name: "exitFullscreen",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"])) : s("", !0),
            b.value ? s("", !0) : (t(), v(f, {
              key: 1,
              name: "fullscreen",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"]))
          ], 64)),
          k.value && e.titles.fullscreen && !l.$slots.optionFullscreen ? (t(), i("div", {
            key: 2,
            dir: "auto",
            class: c({ "button-info-left": e.position === "left", "button-info-right": e.position === "right", "button-info-right-visible": e.position === "right" && n.value.fullscreen, "button-info-left-visible": e.position === "left" && n.value.fullscreen }),
            style: g({ background: e.backgroundColor, color: e.color })
          }, $(e.titles.fullscreen), 7)) : s("", !0)
        ], 32)) : s("", !0),
        e.hasAnimation ? (t(), i("button", {
          key: 9,
          tabindex: "0",
          class: "vue-ui-user-options-button",
          onMouseenter: o[19] || (o[19] = (u) => n.value.animation = !0),
          onMouseout: o[20] || (o[20] = (u) => n.value.animation = !1),
          onClick: O
        }, [
          l.$slots.optionAnimation ? m(l.$slots, "optionAnimation", z(D({ key: 0 }, { toggleAnimation: O, isAnimated: M.value })), void 0, !0) : (t(), i(T, { key: 1 }, [
            M.value ? (t(), v(f, {
              key: 0,
              name: "play",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"])) : s("", !0),
            M.value ? s("", !0) : (t(), v(f, {
              key: 1,
              name: "pause",
              stroke: e.color,
              style: { "pointer-events": "none" }
            }, null, 8, ["stroke"]))
          ], 64)),
          k.value && e.titles.fullscreen && !l.$slots.optionAnimation ? (t(), i("div", {
            key: 2,
            dir: "auto",
            class: c({ "button-info-left": e.position === "left", "button-info-right": e.position === "right", "button-info-right-visible": e.position === "right" && n.value.animation, "button-info-left-visible": e.position === "left" && n.value.animation }),
            style: g({ background: e.backgroundColor, color: e.color })
          }, $(e.titles.animation), 7)) : s("", !0)
        ], 32)) : s("", !0)
      ], 12, oe)
    ], 4)), [
      [Y(ee), N]
    ]);
  }
}, fe = /* @__PURE__ */ Z(ne, [["__scopeId", "data-v-202b6e85"]]);
function le({ domElement: e, fileName: r, format: a = "png" }) {
  if (e)
    return new Promise((B, C) => {
      const h = document.createElement("a");
      _(e, { scale: 2 }).then((y) => {
        h.href = y.toDataURL(`image/${a}`), h.download = `${r}.${a}`, h.click(), h && h.remove(), B();
      }).catch((y) => {
        console.error("Error generating image:", y), C(y);
      });
    });
}
function ve({
  elementId: e,
  fileName: r
}) {
  const a = d(!1), B = d(!1), C = d(null);
  function h() {
    a.value = !0, clearTimeout(C.value), C.value = setTimeout(() => {
      p({
        domElement: document.getElementById(e),
        fileName: r
      }).finally(() => {
        a.value = !1;
      });
    }, 100);
  }
  function y() {
    B.value = !0, clearTimeout(C.value), C.value = setTimeout(() => {
      le({
        domElement: document.getElementById(e),
        fileName: r,
        format: "png"
      }).finally(() => {
        B.value = !1;
      }, 100);
    });
  }
  return {
    generatePdf: h,
    generateImage: y,
    isPrinting: a,
    isImaging: B
  };
}
export {
  fe as U,
  le as s,
  ve as u
};
